unit kalku;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ExtCtrls;

const Znaky:array[0..35]of char = ('0','1','2','3','4','5','6','7','8','9',
  'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R',
  'S','T','U','V','W','X','Y','Z');

type
  TZavorka = record
   Prvni:boolean;
   Operace:byte;
   PrvniC:int64;
  end;

  TKalk = class(TForm)
    Tlac1: TButton;
    Tlac2: TButton;
    Tlac3: TButton;
    Tlac4: TButton;
    Tlac5: TButton;
    Tlac6: TButton;
    Tlac7: TButton;
    Tlac8: TButton;
    Tlac9: TButton;
    Soustava: TSpinEdit;
    KecSoustava: TLabel;
    Tlac0: TButton;
    TlacA: TButton;
    TlacB: TButton;
    TlacC: TButton;
    TlacD: TButton;
    TlacE: TButton;
    TlacF: TButton;
    TlacG: TButton;
    TlacH: TButton;
    TlacI: TButton;
    TlacJ: TButton;
    TlacK: TButton;
    TlacL: TButton;
    TlacM: TButton;
    TlacN: TButton;
    TlacO: TButton;
    TlacP: TButton;
    TlacQ: TButton;
    TlacR: TButton;
    TlacS: TButton;
    TlacT: TButton;
    TlacU: TButton;
    TlacV: TButton;
    TlacW: TButton;
    TlacX: TButton;
    TlacY: TButton;
    TlacZ: TButton;
    TlacUloz: TButton;
    TlacNacti: TButton;
    Panel1: TPanel;
    Vysledek: TLabel;
    TlacZnam: TButton;
    TlacZpet: TButton;
    TlacZrus: TButton;
    Operace: TLabel;
    TlacKrat: TButton;
    TlacDeleno: TButton;
    TlacPlus: TButton;
    TlacMinus: TButton;
    TlacSpocti: TButton;
    TlacMocn: TButton;
    TlacOdmocn: TButton;
    TlacZavL: TButton;
    TlacZavP: TButton;
    procedure Tlac1Click(Sender: TObject);
    procedure TlacZnamClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TlacZrusClick(Sender: TObject);
    procedure TlacPlusClick(Sender: TObject);
    procedure TlacSpoctiClick(Sender: TObject);
    procedure TlacUlozClick(Sender: TObject);
    procedure TlacNactiClick(Sender: TObject);
    procedure TlacZpetClick(Sender: TObject);
    procedure TlacSpoctiKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SoustavaChange(Sender: TObject);
    procedure TlacZavLClick(Sender: TObject);
    procedure TlacZavPClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Pameti:array[0..35]of int64;
    Zavorky:array[1..100] of TZavorka;
    Zavorek:byte;
    Vysl,PrvniC:int64;
    Pocitame:boolean;
    Ukladame,Nacitame:boolean;
    Oper:byte;
    PamOper:string;
    function DesetDo(Soustava:byte;Co:int64):string;
  end;

var
  Kalk: TKalk;

implementation

{$R *.DFM}

function TKalk.DesetDo(Soustava:byte;Co:int64):String;
var Prace:int64;
    Cislo:byte;
begin
 if Co = 0 then Result := '0' else
 begin
  Prace := Abs(Co);
  Result := '';
  repeat
   Cislo := Prace mod Soustava;
   Result := Znaky[Cislo] + Result;
   Prace := Prace div Soustava;
  until Prace < Soustava;
  if Prace <> 0 then Result := Znaky[Prace] + Result;
  if Co < 0 then Result := '-' + Result;
 end;
end;

procedure TKalk.Tlac1Click(Sender: TObject);
begin
 if Nacitame or Ukladame then
 begin
  if Ukladame then Pameti[(Sender as TButton).Tag] := Vysl
  else
  begin
   Vysl := Pameti[(Sender as TButton).Tag];
   Vysledek.Caption := DesetDo(Soustava.Value,Vysl);
  end;
  Operace.Caption := PamOper;
  Ukladame := false;
  Nacitame := false;
 end
 else
 begin
  if (Sender as TButton).Tag < Soustava.Value then
  begin
   if Round((9223372036854775807-(Sender as TButton).Tag)/Soustava.Value)>=Vysl then
   begin
    if (Vysledek.Caption <> '0')or((Sender as TButton).Tag > 0)then
    begin
     if Vysledek.Caption = '0' then Vysledek.Caption := '';
     Vysledek.Caption := Vysledek.Caption + (Sender as TButton).Caption[2];
     Vysl := (Vysl * Soustava.Value) + (Sender as TButton).Tag;
    end;
   end;
  end;
 end;
 TlacSpocti.SetFocus;
end;

procedure TKalk.TlacZnamClick(Sender: TObject);
begin
 if (not Nacitame)and(not Ukladame) then
 begin
  if Vysledek.Caption <> '0' then
  begin
   if Vysledek.Caption[1] = '-' then Vysledek.Caption := Copy(Vysledek.Caption,2,Length(Vysledek.Caption)-1)
                          else Vysledek.Caption := '-' + Vysledek.Caption;
   Vysl := Vysl * -1;
  end;
 end;
 TlacSpocti.SetFocus;
end;

procedure TKalk.FormCreate(Sender: TObject);
begin
 Vysl := 0;
 Pocitame := false;
 Ukladame := false;
 Nacitame := false;
 Zavorek := 0;
end;

procedure TKalk.TlacZrusClick(Sender: TObject);
begin
 Nacitame := false;
 Ukladame := false;
 Operace.Caption := '';
 Vysledek.Caption := '0';
 Vysl := 0;
 TlacSpocti.SetFocus;
end;

procedure TKalk.TlacPlusClick(Sender: TObject);
begin
 if (not Nacitame)and(not Ukladame) then
 begin
  if Pocitame then TlacSpoctiClick(Sender);
  Oper := (Sender as TButton).Tag;
  Pocitame := true;
  if Oper < 5 then
  begin
   Operace.Caption := (Sender as TButton).Caption[2];
   Oper := (Sender as TButton).Tag;
   PrvniC := Vysl;
   Vysl := 0;
   Vysledek.Caption := '0';
  end;
  if Oper in [5..6] then TlacSpoctiClick(Sender);
 end;
 TlacSpocti.SetFocus;
end;

procedure TKalk.TlacSpoctiClick(Sender: TObject);
var Odm:Extended;
begin
 if (not Nacitame) and (not Ukladame) and Pocitame then
 begin
  Pocitame := false;
  Operace.Caption := '';
  case Oper of
    1:Vysl := PrvniC + Vysl;
    2:Vysl := PrvniC - Vysl;
    3:Vysl := PrvniC * Vysl;
    4:Vysl := PrvniC div Vysl;
    5:if Abs(Vysl) > 3037000499 then Operace.Caption := 'nelze'
                                else  Vysl := Vysl * Vysl;
    6:begin
       Odm := Vysl;
       if Vysl < 0 then Operace.Caption := 'nelze'
                  else Vysl := Round(SQRT(Odm));
      end;
  end;
  Vysledek.Caption := DesetDo(Soustava.Value,Vysl);
 end;
end;

procedure TKalk.TlacUlozClick(Sender: TObject);
begin
 if Nacitame then Nacitame := false;
 Ukladame := not Ukladame;
 PamOper := Operace.Caption;
 if Ukladame then Operace.Caption := 'vyber pam'
             else Operace.Caption := '';
 TlacSpocti.SetFocus;
end;

procedure TKalk.TlacNactiClick(Sender: TObject);
begin
 if Ukladame then Ukladame := false;
 Nacitame := not Nacitame;
 PamOper := Operace.Caption;
 if Nacitame then Operace.Caption := 'vyber pam'
             else Operace.Caption := '';
 TlacSpocti.SetFocus;
end;

procedure TKalk.TlacZpetClick(Sender: TObject);
begin
 if Vysledek.Caption <> '0' then
 begin
  Vysledek.Caption := Copy(Vysledek.Caption,1,Length(Vysledek.Caption)-1);
  if (Vysledek.Caption = '') or (Vysledek.Caption = '-')then
  begin
   Vysl := 0;
   Vysledek.Caption := '0';
  end
  else Vysl := Vysl div Soustava.Value;
 end;
 TlacSpocti.SetFocus; 
end;

procedure TKalk.TlacSpoctiKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if Key = 8 then TlacZpetClick(Sender);
end;

procedure TKalk.SoustavaChange(Sender: TObject);
begin
 if Soustava.Value in [2..36] then
 begin
  Vysledek.Caption := DesetDo(Soustava.Value,Vysl);
  TlacSpocti.SetFocus;
 end;
end;

procedure TKalk.TlacZavLClick(Sender: TObject);
begin
 Inc(Zavorek);
 if Pocitame then
 begin
  Zavorky[Zavorek].Prvni := false;
  Zavorky[Zavorek].Operace := Oper;
  Zavorky[Zavorek].PrvniC := PrvniC;
 end
 else Zavorky[Zavorek].Prvni := true;
end;

procedure TKalk.TlacZavPClick(Sender: TObject);
begin
 if Pocitame then TlacSpoctiClick(Sender);


 { aby zavorky slapaly chybi tak deset minut - bohuzel }
end;

end.
